class Admin::PagesController < ApplicationController

  layout "site_editor"
  
  before_filter :authenticate_user!
  before_filter :find_parent_item
  before_filter :is_admin?
  before_filter :set_current_item
  
  def show
    @item = Page.find(params[:id])
    respond_to do |format|
      format.html { 
        render 'admin/items/index' 
      }
      format.js  {}
    end
  end

  def new
    @item = Page.new
    @item.parent = Item.find(params[:parent_id]) rescue nil
    @apps = ModuleApp.excludes(app_pages: nil).entries
    @designs = Design.all.entries
    @design = Design.first
  end

  def edit
    @item = Page.find(params[:id])
    @apps = ModuleApp.excludes(app_pages: nil).entries
	
    @module_apps = ModuleApp.excludes(widgets: nil).where(enable_frontend: true).order_by(:title, :asc)
	
    @designs = Design.all.entries
    @design = @item.design ? @item.design : @designs.first
    @app_frontend_urls = @item.module_app.app_pages if @item.module_app
	
    if @item.module_app
      @module_app = @item.module_app
	
	  @frontend_path = @item.app_frontend_url ? @item.app_frontend_url : @module_app.widgets.keys[0]
	  
	  if @module_app.widgets.any?{|b| b.class == Array}
        @frontend_style =  @module_app.widgets[@frontend_path] if !@frontend_path.blank? && !@module_app.widgets.blank?
	  end
	  
      case @item.module_app.key
        when 'announcement'
          @categories =  BulletinCategory.all
          @tags = AnnouncementTag.all
        when 'news'
          @categories =  NewsBulletinCategory.all
          @tags = NewsTag.all
        when 'web_resource'
          @categories =  WebLinkCategory.all
          @tags = WebResourceTag.all
        when 'archive'
          @categories =  ArchiveFileCategory.all
          @tags = ArchiveTag.all
      end
    else
      @categories = nil
	  @module_app = @module_apps[0]
    end
  end

  def create
    @item = Page.new(params[:page])
	
	if @item.module_app && @item.module_app.key == 'page_content'
	  @item.page_contexts.build(:create_user_id => current_user.id, :update_user_id => current_user.id )
	end
	
    if @item.save
      flash.now[:notice] = t('create.success.page')
      respond_to do |format|
        format.html { 
          redirect_to admin_page_url(@item) 
        }
        format.js {}
      end
    else
      flash.now[:error] = t('create.error.page')
      @apps = ModuleApp.all
      @designs = Design.all.entries
      @design = Design.first
      render :action => "new"
    end
  end

  def update
    @item = Page.find(params[:id])

	  if @item.module_app && @item.module_app.key == 'page_content' && @item.page_contexts.blank?
	    @item.page_contexts.build(:create_user_id => current_user.id, :update_user_id => current_user.id )
	  end
	
	params[:page][:frontend_field] = params[:page][:frontend_field].zip( params[:page][:frontend_field_type] ) if params[:page][:frontend_field] 
	params[:page][:frontend_field_type] = nil
	
    if @item.update_attributes(params[:page])
      flash[:notice] = t('update.success.page')
      respond_to do |format|
        format.html {
          redirect_to admin_page_url(@item) 
        }
        format.js {}
      end
    else
      render :action => "edit"
    end
  end

  def destroy
    @item = Page.find(params[:id])
    @item.destroy
    respond_to do |format|
      format.html { 
        redirect_to admin_items_url( :parent_id => @item.parent_id )
      }
      format.js  { redirect_to admin_items_url }
    end
  end
  
  def delete
    @item = Page.find(params[:id])
    @item.destroy
    respond_to do |format|
      format.html {}
      format.js  { @item = @item.parent }
    end
  end
  
  def reload_themes
    @design = Design.find(params[:id])
    @themes = @design.themes
    respond_to do |format|
      format.js  {}
    end
  end
  
end
